-- version: 0.9 BETA

-- system functions

function image:safeDraw(x,y)
	local l,t=x,y
	local ox,oy=0,0
	local crop=false
	
	if x<0 then
		ox=-x
		l=0
		crop=true
	elseif x+self:width()>screen.width() then
		ox=x+self:width()-screen.width()
		crop=true
	end
	
	if y<0 then
		oy=-y
		t=0
		crop=true
	elseif y+self:height()>screen.height() then
		oy=y+self:height()-screen.height()
		crop=true
	end
	if crop then
		return self:draw(x,y,l,t,self:width()-ox,self:height()-oy)
	else
		return self:draw(x,y)
	end
end

--[[function image:safeDraw(x,y,l,t,w,h)
	if l==nil and t==nil and w==nil and h==nil then
		return self:safeDrawSimple(x,y)
	else
		return self:safeDraw(x,y,l,t,w,h)
	end
end]]

function isZen()
    return debug.traceback():match("a:/") and true
end


-- math extensions

function math.sgn(x)
   if x<0 then
     return -1
   elseif x>0 then
     return 1
   else
     return 0
   end
end

decimalPrecision=2
function math.fix(n,s)
	local nf=n
	local f1=math.floor(n*10^decimalPrecision)/10^decimalPrecision
	local f2=math.ceil(n*10^decimalPrecision)/10^decimalPrecision

	if (nf-f1)<(f2-nf) then f=f1 else f=f2 end
	if math.abs(f)>=s then return f
	else return 0 end
end

function math.round(n)
	local r1=math.floor(n)
	local r2=math.ceil(n)
	if (n-r1)<(r2-n) then return r1 else return r2 end
end


-- buttons

function touch.wsNext()
	x,y=touch.pos()
	return (x>=306 and x<=358 and y>=169 and y<=206)
end

function touch.play()
	x,y=touch.pos()
	return (x>=311 and x<=385 and y>=40 and y<=64)
end

function touch.instructions()
	return (x>=303 and x<=393 and y>=70 and y<=94)
end

function touch.profile()
	return (x>=311 and x<=385 and y>=98 and y<=122)
end

function touch.highscores()
	return (x>=311 and x<=385 and y>=126 and y<=150)
end

function touch.options()
	x,y=touch.pos()
	return (x>=311 and x<=385 and y>=154 and y<=178)
end

function touch.credits()
	x,y=touch.pos()
	return (x>=311 and x<=385 and y>=180 and y<=204)
end

function touch.exit()
	x,y=touch.pos()
	return (x>=311 and x<=385 and y>=211 and y<=235)
end

function touch.profileList()
	x,y=touch.pos()
	return (x>=21 and x<=165 and y>=18 and y<=226)
end

function touch.profileListUp()
	x,y=touch.pos()
	return (x>=167 and x<=203 and y>=15 and y<=51)
end

function touch.profileListDown()
	x,y=touch.pos()
	return (x>=167 and x<=203 and y>=189 and y<=225)
end

function touch.profileNew()
	x,y=touch.pos()
	return (x>=249 and x<=334 and y>=41 and y<=72)
end

function touch.keyboard()
	x,y=touch.pos()
	if x>=8 and x<=392 and y>=60 and y<=235 then		
		local l,t
		
		if y<=164 then
			l,t=x-8,y-60
			
			if l%40<=23 and t%40<=24 then			
				l=(l-l%40)/40+1
				t=(t-t%40)/40+1
				return true,keyboard[t][l]
			else
				return false
			end
		else
			l,t=x-8,y-177
			
			local off=t%40		
			t=(t-t%33)/33+1			
			if t==1 then
				if l<=52 then
					return true,"caps"
				elseif l>=60 and l<=322 then
					l=l-60
					if off<=24 and l%40<=23 then
						l=(l-l%40)/40+1
						return true,keyboard[4][l]
					else
						return false
					end
				elseif l>=331 and l<=383 then
					return true,"backspace"
				end
			else
				if l<=83 then
					return true,"shift"
				elseif l>=101 then
					return true," "
				end
			end
		end
		
	else 
		return false
	end
end

function touch.profileOK()
	x,y=touch.pos()
	return (x>=201 and x<=248 and y>=7 and y<=40)
end

function touch.profileBack()
	x,y=touch.pos()
	return (x>=301 and x<=348 and y>=7 and y<=40)
end

function touch.profileLoad()
	x,y=touch.pos()
	return (x>=242 and x<=343 and y>=91 and y<=122)
end

function touch.profileDel()
	x,y=touch.pos()
	return (x>=242 and x<=343 and y>=139 and y<=170)
end

function touch.profileExit()
	x,y=touch.pos()
	return (x>=342 and x<=387 and y>=200 and y<=229)
end

function touch.hsGlobal()
	x,y=touch.pos()
	return (x>=43 and x<=115 and y>=18 and y<=61)
end

function touch.hsOwn()
	x,y=touch.pos()
	return (x>=134 and x<=206 and y>=18 and y<=66)
end

function touch.arrowU()
	x,y=touch.pos()
	return (x>=362 and x<=392 and y>=64 and y<=88)
end

function touch.arrowD()
	x,y=touch.pos()
	return (x>=362 and x<=392 and y>=214 and y<=238)
end

function touch.charArea()
	x,y=touch.pos()
	return (x>=31 and x<=154 and y>=81 and y<=123)
end

function touch.floorArea()
	x,y=touch.pos()
	return (x>=31 and x<=154 and y>=133 and y<=165)
end

function touch.arrowL()
	x,y=touch.pos()
	return (x>=33 and x<=73 and y>=78 and y<=128)
end

function touch.arrowR()
	x,y=touch.pos()
	return (x>=107 and x<=147 and y>=78 and y<=128)
end

function touch.arrowFL()
	x,y=touch.pos()
	return (x>=28 and x<=68 and y>=132 and y<=172)
end

function touch.arrowFR()
	x,y=touch.pos()
	return (x>=108 and x<=148 and y>=132 and y<=172)
end

function touch.left()
	x,y=touch.pos()
	return (x>140 and x<200 and y>=200 and y<=240)
end

function touch.right()
	x,y=touch.pos()
	return (x>200 and x<260 and y>=200 and y<=240)
end

function touch.enableAcc()
	x,y=touch.pos()
	return (x>=100 and x<=300 and y>=50 and y<=100)
end

function touch.enableTouch()
	x,y=touch.pos()
	return (x>=100 and x<=300 and y>=150 and y<=200)
end

function touch.backToMenu()
	x,y=touch.pos()
	return (x>=110 and x<=206 and y>=160 and y<=190)
end

function touch.tryAgain()
	x,y=touch.pos()
	return (x>=208 and x<=298 and y>=160 and y<=190)
end

function touch.optionsVolUp()
	x,y=touch.pos()
	return (x>=183 and x<=223 and y>=68 and y<=95)
end

function touch.optionsVolDown()
	x,y=touch.pos()
	return (x>=183 and x<=223 and y>=103 and y<=130)
end

function touch.optionsVolMute()
	x,y=touch.pos()
	return (x>=199 and x<=237 and y>=170 and y<=195)
end

function touch.optionsOK()
	x,y=touch.pos()
	return (x>=137 and x<=184 and y>=166 and y<=198)
end

function prepareFloors()
	world.floors[1].width=world.rEdge-world.lEdge
	world.floors[1].pos=world.lEdge
	world.floors[1].style=world.startFloor
	math.randomseed(os.time())
	for i=2,7 do
		if replay then			
			local b1=string.byte(repTemp:read(1))
			local b2=string.byte(repTemp:read(1))
			local b3=string.byte(repTemp:read(1))
			world.floors[i].width=30*b3
			world.floors[i].pos=b1+b2
		else
			world.floors[i].width=30*math.random(world.widthBetween[1].min,world.widthBetween[1].max)
			world.floors[i].pos=math.random(world.lEdge,world.rEdge-world.floors[i].width)
			world.floors[i].style=world.startFloor
		end
		
		if record then
			local b1,b2,b3
		
			if world.floors[i].pos<256 then
				b1=0
				b2=world.floors[i].pos
			else
				b1=world.floors[i].pos-255
				b2=255
			end
			b3=world.floors[i].width/30
		
			repFile:write(string.char(b1),string.char(b2),string.char(b3))
		end		
	end		
end

function drawHSItem(x,y,no,pr,val)	
	if y>-16 and y<scrHeight then
		text.size(16)
		text.color(color.new(0,0,0))
		text.draw(x,y,tostring(no)..". "..pr,"left",x+336)
		text.draw(x,y,tostring(val),"right",x+336)
	end
end

function writeProfileList()
	text.size(20)	
	for i=1,profilesCount do
		if 15+(i-1)*47+menu.profileListShift>-31 and 15+(i-1)*47+menu.profileListShift<scrHeight-15 then
			if i==menu.profileSelected then			
					menu.profileSel:safeDraw(21,15+(i-1)*47+menu.profileListShift)
			end
			if i==profileChoice then
				text.color(color.new(0,0,0))
				text.draw(26,26+(i-1)*47+menu.profileListShift,profiles[i],"center",162)
				text.color(color.new(255,255,255))
				text.draw(25,25+(i-1)*47+menu.profileListShift,profiles[i],"center",161)
			else
				text.color(color.new(0,0,0))
				text.draw(25,25+(i-1)*47+menu.profileListShift,profiles[i],"center",161)
			end
		end		
	end
end

function drawKeyboard()
	text.size(20)
	text.color(color.new(255,255,255))
	
	for i=1,3 do
		for j=1,10 do
			local symbol
			if (keyboard.shift and not keyboard.caps) or (not keyboard.shift and keyboard.caps) then
				symbol=string.upper(keyboard[i][j])
			else
				symbol=keyboard[i][j]
			end
			text.draw(8+(j-1)*40,62+(i-1)*40,symbol,"center",31+(j-1)*40)
		end
	end
	for i=1,7 do
		if (keyboard.shift and not keyboard.caps) or (not keyboard.shift and keyboard.caps) then
			symbol=string.upper(keyboard[4][i])
		else
			symbol=keyboard[4][i]
		end	
		text.draw(68+(i-1)*40,179,symbol,"center",91+(i-1)*40)
	end
	
	
	text.size(36)
	text.draw(10,213,"^","left")
	
	text.size(18)
	text.draw(10,179,"Caps","left")
	
	text.draw(30,213,"Shift","left")
	--text.draw(339,179,"<-","center",392)
end

function drawLastHighScore()
	text.size(12)
	text.color(color.new(0,0,0))
	text.draw(92,161,profiles[profileChoice]..":","left")
	text.draw(92,174,"score: "..highscores[profileChoice].lastScore,"left")
	text.draw(92,187,"combo: "..highscores[profileChoice].lastCombo,"left")
	text.draw(92,200,"floor: "..highscores[profileChoice].lastFloor,"left")
end

function drawPageNumber()
	text.size(14)
	text.color(color.new(0,0,0))
	text.draw(308,200,"page "..menu.instructPage.."/"..table.getn(menu.instructPages))
end

function drawMenu()
	if menu.mainMenu then
		menu.mainBG:draw(0,0)
		
		--text.size(16)
		--text.color(color.new(0,0,0))
		--text.draw(9,19,"profile: "..profiles[profileChoice],"left")
		--text.color(color.new(255,255,255))
		--text.draw(8,18,"profile: "..profiles[profileChoice],"left")
				
		drawLastHighScore()
		
		coroutine.resume(snow,true)
	
	elseif menu.instructMenu then
		--menu.mainBG:draw(0,0)
		--screen.fillrect(0,0,scrWidth,scrHeight,color.new(0,0,0,128))
		menu.instructBG:draw(18,21)
		
		local left=scrWidth/2-menu.instructPages[menu.instructPage]:width()/2
		local top=scrHeight/2-menu.instructPages[menu.instructPage]:height()/2
		if menu.instructSlide==0 then
			menu.instructPages[menu.instructPage]:draw(left,top)
			menu.instructBorder:draw(0,0)
			drawPageNumber()
		elseif menu.instructSlide==-1 then
			
			--if menu.instructPage>1 then
				local prevLeft=left-400+menu.instructPages[menu.instructPage]:width()/2-menu.instructPages[menu.instructPage-1]:width()/2
				local prevTop=scrHeight/2-menu.instructPages[menu.instructPage-1]:height()/2
		
				for i=1,9 do
					--menu.instructBG:draw(0,0,0,22,400,200)
					menu.instructBG:draw(18,21)
					menu.instructCrossFadeLeft[menu.instructPage-1]:safeDraw(prevLeft+i*40,prevTop)
					menu.instructCrossFadeLeft[menu.instructPage]:safeDraw(left+i*40,top)
					menu.instructBorder:draw(0,0,0,21,21,201)
					menu.instructBorder:draw(0,0,377,21,23,201)
					menu.instructBorder:draw(0,0,21,21,356,11)
					screen.update()
					os.wait(10)
				end
				--menu.instructBG:draw(0,0,0,22,400,200)
				menu.instructBG:draw(18,21)
				menu.instructPage=menu.instructPage-1
				menu.instructPages[menu.instructPage]:draw(prevLeft+400,prevTop)
				menu.instructBorder:draw(0,0,0,21,21,201)
				menu.instructBorder:draw(0,0,377,21,23,201)
				menu.instructBorder:draw(0,0,21,21,356,11)
			--end
			menu.instructSlide=0			
			drawPageNumber()
		else
			--if menu.instructPage<table.getn(menu.instructPages) then
				local nextLeft=left+400+menu.instructPages[menu.instructPage]:width()/2-menu.instructPages[menu.instructPage+1]:width()/2
				local nextTop=scrHeight/2-menu.instructPages[menu.instructPage+1]:height()/2
		
				for i=1,9 do
					--menu.instructBG:draw(0,0,0,22,400,200)
					menu.instructBG:draw(18,21)
					menu.instructCrossFadeRight[menu.instructPage]:safeDraw(left-i*40,top)
					menu.instructCrossFadeRight[menu.instructPage+1]:safeDraw(nextLeft-i*40,nextTop)
					menu.instructBorder:draw(0,0,0,21,21,201)
					menu.instructBorder:draw(0,0,377,21,23,201)
					menu.instructBorder:draw(0,0,21,21,356,11)
					screen.update()
					os.wait(10)
				end
				--menu.instructBG:draw(0,0,0,22,400,200)
				menu.instructBG:draw(18,21)
				menu.instructPage=menu.instructPage+1
				menu.instructPages[menu.instructPage]:draw(nextLeft-400,nextTop)
				menu.instructBorder:draw(0,0,0,21,21,201)
				menu.instructBorder:draw(0,0,377,21,23,201)
				menu.instructBorder:draw(0,0,21,21,356,11)
			--end
			menu.instructSlide=0
			drawPageNumber()
		end
	
	elseif menu.creditsMenu then
		menu.creditsBG:draw(0,0)
		
		
	elseif menu.controlsMenu then
	
		black=color.new(0,0,0)
		white=color.new(255,255,255)
		screen.fillrect(0,0,scrWidth,scrHeight,black)
	
		screen.fillrect(100,50,200,50,white)
		screen.fillrect(100,150,200,50,white)
	
		text.color(black)
		text.size(24)
		text.draw(110,60,"Accelerometer")
		text.draw(160,160,"Touch")
	elseif menu.charMenu then
		menu.mainBG:draw(0,0)
		drawLastHighScore()
		
		screen.fillrect(0,0,scrWidth,scrHeight,color.new(0,0,0,128))
		
		local posX,posY=math.floor(scrWidth/2-menu.optBG:width()/2)-50,math.floor(scrHeight/2-menu.optBG:height()/2)
		menu.optBG:draw(posX,posY)		
		--print(posX..", "..posY)
		
		world.floorImages[possibleFloorChoice+1][1]:draw(posX+43,posY+106)
		world.floorImages[possibleFloorChoice+1][3]:draw(posX+73,posY+106)
		
		character.previews[possibleCharChoice]:draw(posX+58,posY+58)
		
		
		text.color(color.new(44,28,12))
		text.size(12)
		text.draw(posX+170,posY+108,"VOLUME: "..audio.volume())
		
		if not menu.optionsMute then
			menu.unmutedBTN:draw(posX+182,posY+137)
		end
		
		--menu.arrowL:safeDraw(165,170)
		--menu.arrowR:safeDraw(215,170)
	elseif menu.profileMenu then
		menu.mainBG:safeDraw(0,0)
		screen.fillrect(0,0,scrWidth,scrHeight,color.new(0,0,0,128))
		menu.profileSelBG:draw(21,15)
		writeProfileList()
		menu.profileBG:draw(0,0)
		
		if profilesCount==1 then
			menu.profileDeactivated:draw(243,139)
		end
		
		menu.mainBG:draw(0,0,0,scrHeight-15,scrWidth,15)
		screen.fillrect(0,scrHeight-15,scrWidth,15,color.new(0,0,0,128))
		menu.profileBG:draw(0,0,0,scrHeight-15,scrWidth,15)
		
	elseif menu.newProfileMenu then
		menu.newProfileTF:draw(4,3)
		text.size(24)
		text.color(color.new(0,0,0))
		text.draw(9,9,menu.newProfileName,"left")
		
		menu.newProfileBG:draw(0,0)
		drawKeyboard()
		
	elseif menu.highscoreMenu then
		menu.mainBG:safeDraw(0,0)
		menu.highscoreBG:safeDraw(0,menu.hsTableShift)		
		if menu.hsGlobal then
			local profilesShown=profilesCount
			if profilesShown>5 then profilesShown=5 end
			
			for i=1,profilesShown do				
				drawHSItem(24,110+(i-1)*20+menu.hsTableShift,i,highscores.global.score[i].profile,highscores.global.score[i].value)
			end
			
			for i=1,profilesShown do
				drawHSItem(24,270+(i-1)*20+menu.hsTableShift,i,highscores.global.combo[i].profile,highscores.global.combo[i].value)
			end
			
			for i=1,profilesShown do
				drawHSItem(24,432+(i-1)*20+menu.hsTableShift,i,highscores.global.floor[i].profile,highscores.global.floor[i].value)
			end
			menu.highscoreHeading:draw(0,0)
			menu.highscoreTop[1]:draw(0,0)			
			
		elseif menu.hsOwn then
			for i=1,table.getn(highscores[profileChoice].score) do
				drawHSItem(24,110+(i-1)*20+menu.hsTableShift,i,profiles[profileChoice],highscores[profileChoice].score[i])
			end
			
			for i=1,table.getn(highscores[profileChoice].combo) do
				drawHSItem(24,270+(i-1)*20+menu.hsTableShift,i,profiles[profileChoice],highscores[profileChoice].combo[i])
			end
			
			for i=1,table.getn(highscores[profileChoice].floor) do
				drawHSItem(24,432+(i-1)*20+menu.hsTableShift,i,profiles[profileChoice],highscores[profileChoice].floor[i])
			end
			menu.highscoreHeading:draw(0,0)		
			menu.highscoreTop[2]:draw(0,0)
		end
		
		menu.arrowUp:draw(364,70)
		menu.arrowDown:draw(364,220)
	elseif menu.welcomeScreen then
		menu.mainBG:draw(0,0)
		menu.wsBG:draw(0,0)
	end
	
	screen.update()
end

function updateScore()
	character.score=world.floor*10+character.comboReward
	drawScore()
end

function comboStart()	
	if world.floor-world.lastFloor>0 then
		character.combo=true
		world.combometer.appearing=true
		character.comboJumps=character.comboJumps+1
		world.combometer.time=14
	end
	character.comboFloors=character.comboFloors+world.floor-world.lastFloor	
	drawCombometer()
end

function selectReward(f)
	if f>=4 and f<=6 then
		return 1
	elseif f>=7 and f<=14 then
		return 2
	elseif f>=15 and f<=24 then
		return 3
	elseif f>=25 and f<=34 then
		return 4
	elseif f>=35 and f<=49 then
		return 5
	elseif f>=50 and f<=69 then
		return 6
	elseif f>=70 and f<=99 then
		return 7
	elseif f>=100 and f<=139 then
		return 8
	elseif f>=140 and f<=199 then
		return 9
	elseif f>=200 then
		return 10
	end
end

function comboEnd(reward)	
	character.combo=false
	if character.comboJumps>1 and reward then
		character.comboReward=character.comboReward+character.comboFloors^2
		if character.bestCombo<character.comboFloors then
			character.bestCombo=character.comboFloors
		end
		
		splash.isReward=true
		splash.rewardZoom=12
		splash.rewardType=selectReward(character.comboFloors)
		
		if not menu.optionsMute and not gameOver then
			sounds.remains=sounds.rewards[splash.rewardType]:time()
			sounds.rewards[splash.rewardType]:play()
		end
	end
	
	character.comboFloors=0
	character.comboJumps=0	
	drawCombometer()
end

function collisionDetection(d) --d=0 > floor, d=1 > air
	if d==1 then
		f=math.floor((scrHeight-character.position.y-character.height)/world.fHeight)
		--lastF=math.floor((scrHeight-character.lastY-character.height+world.shift)/world.fHeight)
		--print("f: "..tostring(f))
		--print("(f+1/2): "..tostring((f+1)/2))	
		if f>-1 and f<13 and f%2==1 and character.position.x+character.width-world.floorEdge>world.floors[(f+1)/2].pos and character.position.x+world.floorEdge<world.floors[(f+1)/2].pos+world.floors[(f+1)/2].width then
			newY=scrHeight-f*20-character.height+world.floor3DSurface
			if newY+character.height+world.shift<scrHeight and gameOver==false then
				character.position.y=newY
				character.inAir=false
				character.falling=false
				world.floor=(f+1)/2-1+world.dropped
				if world.floor-world.lastFloor>=2 or world.floor-world.lastFloor==0 then
					comboStart()
				else
					comboEnd(true)
				end				
				
				updateScore()
				world.lastFloor=world.floor
			end
			--print("W Floor: "..tostring(world.floor))
		end
	else
		if world.floor-world.dropped~=-1 and (character.position.x+character.width-world.floorEdge<=world.floors[world.floor-world.dropped+1].pos or character.position.x+world.floorEdge>=world.floors[world.floor-world.dropped+1].pos+world.floors[world.floor-world.dropped+1].width) then
			character.inAir=true
			character.falling=true
			--character.jumpTdimer=0
		end
	end	
end

function gameOverF()
	comboEnd(false)
	world.combometer.time=0
	gameOver=true
	
	if not menu.optionsMute then
		sounds.gameover:play()
	end
	
	local lev=math.floor(world.floor/100)
	if lev>world.unlocked[profileChoice] then
		world.unlocked[profileChoice]=lev
		
		splash.isReward=true
		splash.rewardZoom=12
		splash.rewardType=11
	end
	
	highscores[profileChoice].lastScore,highscores[profileChoice].lastCombo,highscores[profileChoice].lastFloor=updateHighscores(character.score,character.bestCombo,world.floor)
	updatePrFile()
end

function resetGame(resType)
	if record then
		repTemp:close()
		repTemp=io.open("swap","r")
		local sep=string.char(16)
		repFile:write(sep,sep,sep)
		
		local s=0
		repeat 
			s=repTemp:read(1)
			if s~=nil then repFile:write(s) end			
		until s==nil
		
		repTemp:close()	
		repFile:close()
	end
	
	if replay then
		repTemp:close()
		repFile:close()
	end
			
	pause=false
	gameOver=false	
	world.floor=0
	world.lastFloor=0
	world.dropped=0
	world.shift=0
	world.shiftCounter=0
	world.shiftCounterBG=0
	world.shiftCounterS=0
	bg.shift=0
	world.sidebarShift=0
	--world.period={}
	world.clock.time=0
	world.roll=false
	world.clock.cycle=1
	world.clock.crazy=false
	world.hurry=false
	
	for i,v in ipairs(world.floors) do
		v.style=0
	end
	
	character.velocity=0	
	character.jump=false
	character.jumpTimer=0
	character.jumpVelocity0=nil
	character.jumpVelocity=0
	character.jumpType=0
	character.inAir=false
	character.falling=false
	character.action=nil
	character.lastAction=0
	
	character.comboReward=0
	character.bestCombo=0
	
	character.score=0
	
	character.position.x=(world.rEdge+world.lEdge)/2-character.width/2
	character.position.y=world.bEdge-character.height+world.floor3DSurface
	
	character.lastY=world.bEdge-character.height
	
	character.animTimer=0
	character.idleIn=0
	
	splash.gameoverY=-splash.gameover:height()
	splash.gameoverV=1
	splash.hurryY=scrHeight
	splash.isReward=false
	splash.rewardType=1
	
	sounds.remains=0
	
	fpsCounter=0
	if resType=="menu" then 
		playing=false
		exit=25
		menu.mainMenu=true
		
		screen.clear()
		drawMenu()
	else

		initGame()
	end
end

function shiftWorld(y)
	world.shift=world.shift+y
	
	--print(world.shift)

	if world.shift>=40 then
		world.dropped=world.dropped+1
		for i=2,7 do
			world.floors[i-1].pos=world.floors[i].pos
			world.floors[i-1].width=world.floors[i].width
			world.floors[i-1].style=world.floors[i].style
		end
		l=math.floor((world.dropped+7)/100)+1
		s=l+world.startFloor
		if l>table.getn(world.widthBetween) then l=table.getn(world.widthBetween) end
		if s>table.getn(world.floorImages) then s=table.getn(world.floorImages) end
		
		if replay then
			--print("it works")
			local b1=string.byte(repTemp:read(1))
			local b2=string.byte(repTemp:read(1))
			local b3=string.byte(repTemp:read(1))
			
			world.floors[7].width=30*b3
			world.floors[7].pos=b1+b2
						
			if (6+world.dropped)%50==0 then			
				world.floors[7].style=s-1
			end
			
		elseif (6+world.dropped)%50==0 then
			world.floors[7].width=world.rEdge-world.lEdge
			world.floors[7].pos=world.lEdge
			world.floors[7].style=s-1			
		else			
			world.floors[7].width=30*math.random(world.widthBetween[l].min,world.widthBetween[l].max)
			--print("Width: "..tostring(world.floors[7].width))
			world.floors[7].pos=math.random(world.lEdge,world.rEdge-world.floors[7].width)
			--print("Pos: "..tostring(world.floors[7].pos))
		end
		
		
		if record then
			local b1,b2,b3
		
			if world.floors[7].pos<256 then
				b1=0
				b2=world.floors[7].pos
			else
				b1=world.floors[7].pos-255

				b2=255
			end
			b3=world.floors[7].width/30
		
			repFile:write(string.char(b1),string.char(b2),string.char(b3))
		end
		
		world.shift=world.shift-40
		character.position.y=character.position.y+40
		return true
	else
		return false
	end
end

function shiftBG(s)
	bg.shift=bg.shift+s
	if bg.shift>=scrHeight then bg.shift=bg.shift-scrHeight end
end

function shiftSidebar()
	world.sidebarShift=world.sidebarShift+1
	if world.sidebarShift==scrHeight then world.sidebarShift=0 end
end

function autoRoll()
	world.shiftCounter=(world.shiftCounter*10+world.speed[world.clock.cycle]*10)/10
	world.shiftCounterBG=world.shiftCounterBG+world.speed[world.clock.cycle]/2
	--world.shiftCounterS=world.shiftCounterS+world.speed[world.clock.cycle]*10
	
	--shift background
	local r=math.floor(world.shiftCounterBG)
	if r>=1 then
		shiftBG(r)
		world.shiftCounterBG=world.shiftCounterBG-r
	end
	
	--shift world
	
	r=math.floor(world.shiftCounter)
	if r>=1 then
		shiftWorld(r)
		world.shiftCounter=(world.shiftCounter*10-r*10)/10
		return r
	end
	
	--shift sidebar
	--[[r=math.floor(world.shiftCounterS)
	if r>=1 then
		shiftSidebar(r)
		world.shiftCounterS=world.shiftCounterS-r
	end]]
	return 0
end

function updatePlayerPos(a,dy) -- (x)
	if replay then
		character.velocity=a
		character.position.x=math.floor((character.position.x*100 + character.velocity*100)/100)
		
		if (character.position.x<world.lEdge) then
			character.position.x = world.lEdge
			lastLPF_x_dir=-lastLPF_x_dir
			character.velocity=-character.velocity
			
		elseif (character.position.x > (world.rEdge-character.width)) then
			character.position.x = world.rEdge-character.width;
			lastLPF_x_dir=-lastLPF_x_dir
			character.velocity=-character.velocity			
		end
		
	elseif accControl then
		vel = 0;
		if (a > 0.5) then
			vel = -vMulti * a;
			if (vel < -15) then
				vel = -15
			end
		elseif (a < -0.5) then
			vel = -vMulti * a;
			if (vel > 15) then
				vel = 15;
			end
		end
		character.velocity = math.fix((0.8 * vel) + (0.2 * character.velocity),accSpeedError);
		--print(character.velocity)
		character.position.x = math.floor(character.position.x + character.velocity);
		if (character.position.x<world.lEdge) then
			character.position.x = world.lEdge
			lastLPF_x_dir=-lastLPF_x_dir
			character.velocity=-character.velocity
			
		elseif (character.position.x > (world.rEdge-character.width)) then
			character.position.x = world.rEdge-character.width;
			lastLPF_x_dir=-lastLPF_x_dir
			character.velocity=-character.velocity
			
		end
	elseif touchControl then
	
		--if enableAccIn==0 then accControl=true end
	
		if a==startRunningLeft then
			if math.abs(character.velocity)<character.maxVelocity then
				character.velocity=math.fix(character.velocity-stepUp,stepUp)
			end
		elseif a==startRunningRight then
			if math.abs(character.velocity)<character.maxVelocity then
				character.velocity=math.fix(character.velocity+stepUp,stepUp)
			end
		elseif a==stopRunning then
			if math.abs(character.velocity)>0 then
				if character.velocity<0 then character.velocity=math.fix(character.velocity+stepDown,stepDown)
				elseif character.velocity>0 then character.velocity=math.fix(character.velocity-stepDown,stepDown) end
			else character.action=nil end
		elseif a==shortRunLeft then
			if math.abs(character.velocity)<character.maxVelocity*0.05 then
				character.velocity=math.fix(character.velocity-stepUp,stepUp)
			else character.action=stopRunning end
		elseif a==shortRunRight then
			if math.abs(character.velocity)<character.maxVelocity*0.05 then
				character.velocity=math.fix(character.velocity+stepUp,stepUp)
			else character.action=stopRunning end
		end
	
		character.position.x=math.floor(character.position.x + character.velocity)
		if character.position.x<world.lEdge then character.position.x=world.lEdge
		elseif character.position.x>world.rEdge-character.width then character.position.x=world.rEdge-character.width end
	
	end
	
	if character.inAir==false then
		character.jumpTimer=0
	
		--autoslide correction
		--if character.position.y+world.shift<scrHeight/4 then shiftWorld(1) end
		
		collisionDetection(0)
		
		--Jump SPEED definition		10, 14, 18, 20, 22
		if math.abs(character.velocity)<4 then
			character.jumpVelocity0=10
			character.jumpType=1
			--character.jumpVelocity0=1.4*12.9
			--character.jumpType=3
		elseif math.abs(character.velocity)<8 then
			character.jumpVelocity0=14
			character.jumpType=2
		elseif math.abs(character.velocity)<12 then
			character.jumpVelocity0=18
			character.jumpType=2
		elseif math.abs(character.velocity)<14 then
			character.jumpVelocity0=20
			character.jumpType=3
		else
			character.jumpVelocity0=22
			character.jumpType=3
		end
	end
	
	character.lastY=character.position.y
	local shifted=false
	
	if (character.jump) and (character.inAir==false) then		
		character.inAir=true
		character.jumpTimer=0
		--character.lastY=character.position.y
		
		character.position.y=math.floor(character.position.y-character.jumpVelocity0)
		
		character.jumpTimer=character.jumpTimer+interval
		
		if not menu.optionsMute then
			local jumpSnd=""
			if character.jumpType==1 then
				jumpSnd="jumpLo"
			elseif character.jumpType==2 then
				jumpSnd="jumpMid"
			elseif character.jumpType==3 then
				jumpSnd="jumpHi"
			end
			if sounds.remains==0 then
				sounds[jumpSnd]:play()
			end
		end
		
	elseif(character.inAir) then
		if character.falling then
			character.jumpVelocity=-world.g*world.m*character.jumpTimer
			character.jumpTimer=character.jumpTimer+interval
			--character.lastY=character.position.y
			--if replay then
			--	character.position.y=character.position.y-dy
			--else
				character.position.y=math.floor((character.position.y*100-character.jumpVelocity*100)/100)
			--end
						
			collisionDetection(1)
		else
			character.jumpVelocity=character.jumpVelocity0-world.g*world.m*character.jumpTimer
			character.jumpTimer=character.jumpTimer+interval
			--character.lastY=character.position.y
			--if replay then

			--	character.position.y=character.position.y-dy
			--else
				character.position.y=math.floor((character.position.y*100-character.jumpVelocity*100)/100)
			--end
			if character.lastY-character.position.y>0 and character.position.y+world.shift<scrHeight/4 then
				shifted=shiftWorld(character.lastY-character.position.y)				
				--shiftBG(math.floor((character.lastY-character.position.y)/2))
			end
			
			if character.jumpVelocity<0 then collisionDetection(1) end			
		end
	end
	
	--print("v: "..character.jumpVelocity.." s: "..dy)
		
	if record then
		local byte=math.floor(character.velocity)
		if byte<0 then byte=byte+32 end
		if character.jump then byte=byte+128 end
		
		repTemp:write(string.char(byte))
		
		--log:write(character.velocity,string.char(13), string.char(10))
		
		byte=character.velocity*100-math.floor(character.velocity)*100
		repTemp:write(string.char(byte))
		
		--[[byte=character.lastY-character.position.y
		if shifted then byte=byte+40 end
		if byte<0 then byte=byte+256 end
		repTemp:write(string.char(byte))]]
	end
end

function animateStanding()
	x,y=character.position.x,character.position.y+world.shift
	
	if character.lastAction==1 then
		character.images[walk[1]]:safeDraw(x,y)
	elseif character.lastAction==-1 then
		character.images[walk[5]]:safeDraw(x,y)
	else
		character.images[idle[1]]:safeDraw(x,y)
	end
end

function animateIdle()
	x,y=character.position.x,character.position.y+world.shift
	
	if character.animTimer==40 then character.animTimer=0 end
	
	character.images[idle[math.floor(character.animTimer/10)+1]]:safeDraw(x,y)

	if not pause then character.animTimer=character.animTimer+1 end
end

function animateWalk(direction)
	x,y=character.position.x,character.position.y+world.shift

	if direction<0 then idx=5 else idx=1 end
	
	if character.animTimer==20 then character.animTimer=0 end

	character.images[walk[idx+math.floor(character.animTimer/5)]]:safeDraw(x,y)
	
	if not pause then character.animTimer=character.animTimer+1 end
	
end

function animateJump(direction)
	x,y=character.position.x,character.position.y+world.shift
	
	if character.jumpType==1 then
		character.images[jump[1][1]]:safeDraw(x,y)
	elseif character.jumpType==2 or character.falling then		
		if character.velocity<0 then idx=4 else idx=1 end
		if math.abs(character.jumpVelocity)<2 then
			character.images[jump[2][idx+1]]:safeDraw(x,y)
		elseif character.jumpVelocity>0 then
			character.images[jump[2][idx]]:safeDraw(x,y)
		else
			character.images[jump[2][idx+2]]:safeDraw(x,y)
		end
	else
		character.width=character.images[jump[3][1]]:width()
		if character.position.x+character.width>world.rEdge then
			character.position.x=world.rEdge-character.width
			x=character.position.x
		end
		
		if character.animTimer==16 then character.animTimer=0 end
		
		if direction<0 then
			b=1
			s=0
		else
			b=-1
			s=9
		end
		
		character.images[jump[3][(math.floor(character.animTimer/2)+1)*b+s]]:safeDraw(x,y)
		
		if not pause then character.animTimer=character.animTimer+1 end
	end
end

function animateEdge(direction)
	x,y=character.position.x,character.position.y+world.shift
	
	if not menu.optionsMute and sounds.remains==0 then
		local delay=500
		if not is_zen then delay=0 end
		sounds.remains=sounds.edge:time()+delay
		sounds.edge:play()
	end
	
	if character.animTimer==20 then character.animTimer=0 end
	
	if character.position.x+character.width>world.rEdge then
		character.position.x=world.rEdge-character.width
		x=character.position.x
	end
	
	character.images[edge[direction][math.floor(character.animTimer/10)+1]]:safeDraw(x,y)

	if not pause then character.animTimer=character.animTimer+1 end
end

function animateChock()
	x,y=character.position.x,character.position.y+world.shift
	character.images[chock]:safeDraw(x,y)
end

function drawFloor(x,y,width,height,style)
	local wch=width/30
	
	if width==world.rEdge-world.lEdge then		
		for i=1,wch do
			world.floorImages[style][2]:safeDraw(x+(i-1)*30,y)
		end
	else
		world.floorImages[style][1]:safeDraw(x,y)
		for i=1,wch-2 do
			world.floorImages[style][2]:safeDraw(x+i*30,y)
		end
		world.floorImages[style][3]:safeDraw(x+width-30,y)
	end
end

function drawVisibleFloors()
	white=color.new(255,255,255)
	black=color.new(0,0,0)	
	
	for i=1,7 do		
		--s=math.floor((i+world.dropped-1)/100)+1
		s=world.floors[i].style+1
		if s>table.getn(world.floorImages) then s=table.getn(world.floorImages) end
		drawFloor(world.floors[i].pos,world.bEdge+world.shift-40*(i-1),world.floors[i].width,15,s)
		
		if (i+world.dropped-1~=0) and (i+world.dropped-1)%10==0 then
			--screen.drawrect(world.floors[i].pos+world.floors[i].width/2-15,world.bEdge+world.shift-40*(i-1)+1,world.floors[i].pos+world.floors[i].width/2+14,world.bEdge+world.shift-40*(i-1)+16,black)
			--screen.fillrect(world.floors[i].pos+world.floors[i].width/2-14,world.bEdge+world.shift-40*(i-1)+2,28,14,white)
			
			ls=math.ceil(world.floorImages[s][4]:width()/2)
			
			world.floorImages[s][4]:safeDraw(world.floors[i].pos+world.floors[i].width/2-ls,world.bEdge+world.shift-40*(i-1)+3)
			
			if world.floor<1000 then
				text.size(10)
			else
				text.size(8)
			end
			
			
			text.color(black)
			text.draw(world.floors[i].pos+world.floors[i].width/2-ls+1,world.bEdge+world.shift-40*(i-1)+6,tostring(i+world.dropped-1),"center",world.floors[i].pos+world.floors[i].width/2+ls+1)
			text.color(white)
			text.draw(world.floors[i].pos+world.floors[i].width/2-ls,world.bEdge+world.shift-40*(i-1)+5,tostring(i+world.dropped-1),"center",world.floors[i].pos+world.floors[i].width/2+ls)
		end
	end
end

function drawClock(f)	
	local left=4
	if world.hurry and sounds.remains>0 then
		left=4+((world.clock.time%2)*2-1)		
	end
	
	world.sideBar[1]:draw(0,0,4,0,50,58)
	
	world.clock.img:draw(left,0)
	world.clock.drawPointer(f,left,0)
end

function drawNumber(x,y,n,alignment,x2)
	local length=math.floor(math.log10(n)+1)
	local left
	
	if alignment=="center" then
		left=(x+x2)/2-(length*14)/2
	end
	
	b=n
	for i=length,1,-1 do
		digit=b%10
		if digit==0 then digit=10 end
		b=(b-b%10)/10
		font.number[digit]:safeDraw(left+(i-1)*14,y)
	end
end

function drawCombometer(b)
	if b=="base" then
		world.combometer.base:draw(18,65)
		if character.combo then
			world.combometer.floors:draw(0,120)
			if world.combometer.time%2==0 then
				for i=1,world.combometer.time/2 do
					world.combometer.point[2]:draw(25,126-9*(i-1))
				end
			else
				for i=1,(world.combometer.time-1)/2 do
					world.combometer.point[2]:draw(25,126-9*(i-1))
				end
				world.combometer.point[1]:draw(25,126-9*(world.combometer.time-1)/2)
			end
		end
	end
	--world.sideBar[1]:safeDraw(0,world.sidebarShift,0,64,68,118)
	if character.combo==false then		
		world.combometer.noFloors:safeDraw(0,120)
		if world.combometer.time>0 then
			for i=math.ceil(world.combometer.time/2),0,-1 do
				world.combometer.base:draw(18,65,25,72+9*(6-i),8,8)
			end
		end
	else
		if world.combometer.appearing then 
			world.combometer.floors:safeDraw(0,120)
			world.combometer.appearing=false
		end
		
		if world.combometer.time%2==0 then
			
			if world.combometer.time==14 then
				for i=1,world.combometer.time/2 do
					world.combometer.point[2]:safeDraw(25,126-9*(i-1))
				end
			else
				world.combometer.base:draw(18,65,25,72+9*(6-world.combometer.time/2),8,8)
			end
			
		else
			world.combometer.base:draw(18,65,25,72+9*(6-(world.combometer.time-1)/2),8,8)
			world.combometer.point[1]:safeDraw(25,72+9*(6-(world.combometer.time-1)/2))			
		end
		
		drawNumber(-2,137,character.comboFloors,"center",56)
		
	end
end

function drawSidebar()
	world.sideBar[1]:safeDraw(0,world.sidebarShift)
	world.sideBar[2]:safeDraw(scrWidth-11,world.sidebarShift)
	
	--world.combometer.main:safeDraw(-6,64)
	drawCombometer("base")
	
	if world.sidebarShift>0 then
		world.sideBar[1]:safeDraw(0,world.sidebarShift-scrHeight)
		world.sideBar[2]:safeDraw(scrWidth-11,world.sidebarShift-scrHeight)
	end
		
	drawClock(math.floor(world.clock.time/3)+1)
	
	white=color.new(255,255,255)
	black=color.new(0,0,0)
	text.size(14)
		
	local s="score:"
	text.color(black)
	text.draw(4,scrHeight-18-20,s,"center",54)
	text.color(white)
	text.draw(3,scrHeight-19-20,s,"center",53)
	
	screen.drawline(3,scrHeight-18-3,55,scrHeight-18-3,black)
	screen.drawline(2,scrHeight-19-3,54,scrHeight-19-3,color.new(192,192,192))
	
	updateScore()
end

function drawSplash()
	if world.hurry then
		splash.hurryY=splash.hurryY-5
		splash.hurry:safeDraw((world.rEdge+world.lEdge)/2-(splash.hurry:width()+1)/2,splash.hurryY)
		if splash.hurryY<=-splash.hurry:height() then
			world.hurry=false
			splash.hurryY=scrHeight
		end
	end
end

function drawSplashOver()
	local newFloorSplTop=28
	if splash.isReward and splash.rewardZoom>11 then
		local rNum=splash.rewardType
		local ratio=math.sin(splash.rewardZoom/100)
		local width,height=math.round(splash.rewards[rNum]:width()*ratio),math.round(splash.rewards[rNum]:height()*ratio)
		--print("w: "..width..", h: "..height)
		--screen.fillrect(0,0,400,240,color.new(0,0,0))
		if rNum~=11 then
			splash.rewards[rNum]:draw(math.floor((world.rEdge+world.lEdge)/2-width/2),math.floor(scrHeight/2-height/2),width,height)
		else
			splash.rewards[rNum]:draw(math.floor((world.rEdge+world.lEdge)/2-width/2),math.floor(newFloorSplTop-height/2),width,height)
		end
		splash.rewardZoom=splash.rewardZoom+12
		if splash.rewardZoom>156 then
			splash.rewardZoom=-24
			--splash.isReward=false
		end
	elseif splash.isReward or splash.rewardType==11 then
		local width,height=splash.rewards[splash.rewardType]:width(),splash.rewards[splash.rewardType]:height()
		if splash.rewardType~=11 then
			splash.rewards[splash.rewardType]:draw(math.floor((world.rEdge+world.lEdge)/2-width/2),math.floor(scrHeight/2-height/2),width,height)
		else
			splash.rewards[splash.rewardType]:draw(math.floor((world.rEdge+world.lEdge)/2-width/2),math.floor(newFloorSplTop-height/2),width,height)
		end
		splash.rewardZoom=splash.rewardZoom+1
		if splash.rewardZoom>0 then
			splash.isReward=false
		end
	end	
end

function drawScore()
	world.sideBar[1]:draw(0,world.sidebarShift,0,scrHeight-20,58,20)

	local s=tostring(character.score)
	text.size(14)
	text.color(black)
	text.draw(4,scrHeight-18,s,"right",54)
	text.color(white)
	text.draw(3,scrHeight-19,s,"right",53)
end


function redraw()	
	--[[if is_zen then
		newtime=os.ostime()
		log:write(newtime-oldtime,string.char(13),string.char(10))
		oldtime=newtime
	end]]
	
	
	bg.img:safeDraw(58,bg.shift)
	if bg.shift>0 then
		bg.img:safeDraw(58,bg.shift-scrHeight)
	end
	--bg.img:draw(58,0)
	
	drawSplash()	
	
	--sidebar
	
	
	
	--[[
	if world.clock.time%10==0 then
		world.clock.pFrame=world.clock.pFrame+1
		if world.clock.pFrame==120 then world.clock.pFrame=1 end		
	end
	]]
	
	--world.clock.pointer[world.clock.pFrame]:safeDraw(4,0)
	
	drawVisibleFloors()	
	--drawSidebar()
	
	if character.inAir==false then
		if not balance then
			character.width=character.images[idle[1]]:width()			
		end
		if math.abs(character.velocity)<2 then
			balance=true
		else
			balance=false
		end
		
		if balance and character.position.x+character.width/2<world.floors[world.floor-world.dropped+1].pos+world.floorEdge then
			if character.lastAction~=-3 then
				character.width=character.images[edge[2][1]]:width()				
				character.animTimer=0
				character.lastAction=-3
			end
			animateEdge(2)	
			
		elseif balance and character.position.x+character.width>world.floors[world.floor-world.dropped+1].pos+world.floors[world.floor-world.dropped+1].width+world.floorEdge then
			if character.lastAction~=3 then
				character.width=character.images[edge[1][1]]:width()				
				character.animTimer=0
				character.lastAction=3
			end
			animateEdge(1)
			
		elseif character.velocity==0 then
			if character.lastAction~=0 then
				character.animTimer=0
			end
			if world.floor~=0 and scrHeight-character.position.y-world.shift-character.height+world.floor3DSurface<2*world.fHeight then
				animateChock()
				character.lastAction=0
			elseif character.idleIn==0 then
				animateIdle()
				character.lastAction=0
			else
				animateStanding()
				character.idleIn=character.idleIn-1
			end
		elseif character.velocity<0 then
			if character.lastAction~=-1 then
				character.lastAction=-1
				character.animTimer=0
			end
			character.idleIn=idleDelay

			animateWalk(-1)
		else 
			if character.lastAction~=1 then
				character.lastAction=1
				character.animTimer=0
			end
			character.idleIn=idleDelay
			animateWalk(1)
		end		
	else
		if character.lastAction~=2 then
			character.lastAction=2
			character.animTimer=0
			d=math.sgn(character.velocity)			
		end
		character.idleIn=idleDelay
		animateJump(d)
	end
	
	--if touchControl then ctrl:safeDraw(0,200) end
	
	--drawScore()
	
	drawSplashOver()
	
	if pause then
		pauseScr:draw(0,0)
	end
	
	if gameOver then
		--local left=scrWidth/2-math.floor(splash.gameover:width()/2)
		local left=math.floor((world.lEdge+world.rEdge)/2-splash.gameover:width()/2)
		--drawSidebar()
		--dark=color.new(0,0,0,123)
		--screen.fillrect(0,0,scrWidth,scrHeight,dark)
		splash.gameover:safeDraw(left,splash.gameoverY)
		black=color.new(0,0,0)
		white=color.new(255,255,255)
		text.size(14)
		local s=tostring(character.score)
		local f=tostring(world.floor)
		local c=tostring(character.bestCombo)
		text.color(black)
		text.draw(left+8,splash.gameoverY+90,s,"right",left+splash.gameover:width()-8)
		text.draw(left+8,splash.gameoverY+90+25,f,"right",left+splash.gameover:width()-8)
		text.draw(left+8,splash.gameoverY+90+50,c,"right",left+splash.gameover:width()-8)
		text.color(white)
		text.draw(left+7,splash.gameoverY+89,s,"right",left+splash.gameover:width()-9)
		text.draw(left+7,splash.gameoverY+89+25,f,"right",left+splash.gameover:width()-9)
		text.draw(left+7,splash.gameoverY+89+50,c,"right",left+splash.gameover:width()-9)
		
	end
	
	screen.update()
end

function initGame()
	if record then
		repFile=io.open("replay.ztr","w+")
		--os.wait(10)
		repTemp=io.open("swap","w+")
	end
	if replay then
		repFile=io.open("replay.ztr","r")		
		repTemp=io.open("swap","w+")
		
		local s1,s2,s3
		eof=false
		repeat
		s1=repFile:read(1)
		s2=repFile:read(1)
		s3=repFile:read(1)
		
		if string.byte(s1)==16 and string.byte(s2)==16 and string.byte(s3)==16 then
			eof=true
		else
			repTemp:write(s1,s2,s3)
		end
		until eof
		
		repTemp:close()
		repTemp=io.open("swap","r")		
	end
	
	screen.clear()
	
	prepareFloors()
	drawSidebar()
	
	if audio.channel()==0 and not menu.optionsMute then
		sounds.maxVol=14
		if audio.volume()>sounds.maxVol then
			sounds.lastVol=audio.volume()
			audio.volume(sounds.maxVol)
		end
	end
	
	if not menu.optionsMute then
		sounds.remains=sounds.hello:time()
		sounds.hello:play()		
	end
end

function updateChar()

	for i,v in ipairs(character.images) do
		v:close()
	end

	character.images={
		image.load("characters/"..chars[charChoice].."/idle1.png"),
		image.load("characters/"..chars[charChoice].."/walk1.png"),
		image.load("characters/"..chars[charChoice].."/walk2.png"),
		image.load("characters/"..chars[charChoice].."/walk3.png"),
		image.load("characters/"..chars[charChoice].."/walk4.png"),
		image.load("characters/"..chars[charChoice].."/walk5.png"),
		image.load("characters/"..chars[charChoice].."/walk6.png"),
		image.load("characters/"..chars[charChoice].."/walk7.png"),
		image.load("characters/"..chars[charChoice].."/walk8.png"),
		image.load("characters/"..chars[charChoice].."/idle2.png"),
		image.load("characters/"..chars[charChoice].."/idle3.png"),
		image.load("characters/"..chars[charChoice].."/jump.png"),
		image.load("characters/"..chars[charChoice].."/jump1.png"),
		image.load("characters/"..chars[charChoice].."/jump2.png"),
		image.load("characters/"..chars[charChoice].."/jump3.png"),
		image.load("characters/"..chars[charChoice].."/jump4.png"),
		image.load("characters/"..chars[charChoice].."/jump5.png"),
		image.load("characters/"..chars[charChoice].."/jump6.png"),
		image.load("characters/"..chars[charChoice].."/rotate0.png"),
		image.load("characters/"..chars[charChoice].."/rotate45.png"),
		image.load("characters/"..chars[charChoice].."/rotate90.png"),
		image.load("characters/"..chars[charChoice].."/rotate135.png"),
		image.load("characters/"..chars[charChoice].."/rotate180.png"),
		image.load("characters/"..chars[charChoice].."/rotate225.png"),
		image.load("characters/"..chars[charChoice].."/rotate270.png"),
		image.load("characters/"..chars[charChoice].."/rotate315.png")
	}
	
	for i=27,30 do
		character.images[i]=image.load("characters/"..chars[charChoice].."/edge"..tostring(i-26)..".png")
	end
	
	character.images[31]=image.load("characters/"..chars[charChoice].."/chock.png")
	
	for k,v in pairs(sounds) do
		if string.find(tostring(sounds[k]),"wave")~=nil then
			sounds[k]:close()
		end
	end
	
	loadCharSound("hello","hello.wav")
	loadCharSound("pause","pause.wav")
	loadCharSound("edge","edge.wav")
	loadCharSound("gameover","falling.wav")	
	loadCharSound("jumpLo","jump_lo.wav")
	loadCharSound("jumpMid","jump_mid.wav")
	loadCharSound("jumpHi","jump_hi.wav")

end

lastTime=os.ostime()
dots=0

function drawDots(d)
	dot1={x=222,y=132}
	dot2={x=228,y=132}
	if d==0 then
		--loadingNoDots:safeDraw(dot1.x,dot1.y)
		loadingScr:draw(0,0,dot1.x,dot1.y,15,8)
	elseif d==1 then
		loadingDot:draw(dot1.x,dot1.y)
	else
		loadingDot:draw(dot2.x,dot2.y)
	end
	screen.update()
end

function loadingF(isLoading)
	while isLoading do
		--print(isLoading)
		c=os.ostime()
		if c-lastTime>=500 then
			dots=(dots+1)%3
			drawDots(dots)
			lastTime=c
		end
		coroutine.yield()
	end
end

function goCheckButtons()
	while control.read()==1 do end
	if control.read(1)==1 then
		if control.isTouch()==1 then
			if touch.click()==1 then
				if touch.backToMenu() then
					if not menu.optionsMute then
						playMenuSound("select")
					end
					resetGame("menu")
				end
				if touch.tryAgain() then resetGame() end
			end
		end
	end
end

function intToBytes(n)
	local x=n
	local b={0,0,0,0}
	
	b[4]=x%256
	x=(x-b[4])/256
	b[3]=x%256
	x=(x-b[3])/256
	b[2]=x%256

	x=(x-b[2])/256
	b[1]=x
	
	return b[1],b[2],b[3],b[4]
end

function wordToBytes(n)
	local x=n
	local b={0,0}
	
	b[2]=x%256
	x=(x-b[2])/256
	b[1]=x
	
	return b[1],b[2]
end

function bytesToInt(b1,b2,b3,b4)
	return 256^3*b1+256^2*b2+256*b3+b4
end

function bytesToWord(b1,b2)
	return 256*b1+b2
end

--[[function createFirstProfile()
	local prName="default"
	prFile=io.open("profiles.dat","w+")
	
	prFile:write(string.char(1))

	prFile:write(prName..";")
	for i=1,40 do
		prFile:write(string.char(0))
	end
	prFile:close()
end]]

function createNewProfile(name)
	profilesCount=profilesCount+1
	profiles[profilesCount]=name
	highscores[profilesCount]={
		score={},
		combo={},
		floor={},
		lastScore=0,
		lastCombo=0,
		lastFloor=0
	}
	for i=1,5 do		
		highscores[profilesCount].score[i]=0
		highscores[profilesCount].combo[i]=0
		highscores[profilesCount].floor[i]=0
	end
	
	settings.character[profilesCount]=1
	settings.floor[profilesCount]=0
	charChoice=1
	world.startFloor=0
	updateChar()
	
	world.unlocked[profilesCount]=0
	
	updatePrFile()
end

function deleteProfile(prNumber)
	table.remove(profiles,prNumber)
	table.remove(highscores,prNumber)
	table.remove(world.unlocked,prNumber)
	
	table.remove(settings.character,prNumber)
	table.remove(settings.floor,prNumber)
	
	if prNumber<profileChoice then
		profileChoice=profileChoice-1
	elseif prNumber==profileChoice then
		profileChoice=1
	end
	world.startFloor=settings.floor[profileChoice]
	
	profilesCount=profilesCount-1
	
	if menu.profileSelected>profilesCount then
		menu.profileSelected=profilesCount
	end
	
	if menu.profileListShift<-profilesCount*46+210 then
		menu.profileListShift=-profilesCount*46+210
	end
	
	if menu.profileListShift>0 then
		menu.profileListShift=0
	end
	
	charChoice=settings.character[profileChoice]
	updateChar()
	
	updatePrFile()
end

function delProfileQuery()
	local left,top=scrWidth/2-menu.profileDel:width()/2,scrHeight/2-menu.profileDel:height()/2
	menu.profileDel:draw(left,top)
	screen.update()
	local confirm=false
	while not confirm do
		if control.read(1)==1 and control.isTouch()==1 and touch.click()==1 then
			local x,y=touch.pos()
			if (x>=left+41) and (x<=left+90) and (y>=top+68) and (y<=top+102) then
				playMenuSound("confirm")
				deleteProfile(menu.profileSelected)
				confirm=true
			elseif (x>=left+119) and (x<=left+168) and (y>=top+68) and (y<=top+102) then
				confirm=true
			end
		end
	end
	drawMenu()
end

function exitQuery()
	local left,top=scrWidth/2-menu.quitImg:width()/2,scrHeight/2-menu.quitImg:height()/2
	menu.quitImg:draw(left,top)
	screen.update()
	local confirm=false
	while not confirm do
		if control.read(1)==1 and control.isTouch()==1 and touch.click()==1 then
			local x,y=touch.pos()
			if (x>=left+44) and (x<=left+94) and (y>=top+66) and (y<=top+101) then
				playMenuSound("confirm")
				
				comboEnd(false)
				world.combometer.time=0
				gameOver=true
				resetGame("menu")
				
				confirm=true
			elseif (x>=left+122) and (x<=left+172) and (y>=top+66) and (y<=top+101) then
				drawSidebar()
				redraw()				
				confirm=true
			end
		end
	end
end

function loadProfiles()
	prFile=io.open("profiles.dat","r")
	
	local pc=string.byte(prFile:read(1))
	
	for i=1,pc do
		local nameStr=""
		local eos=false
		repeat
			ch=prFile:read(1)
			if ch==";" then eos=true else nameStr=nameStr..ch end			
		until eos
		profiles[i]=nameStr
	end
	
	--load highscores
	for i=1,pc do
		highscores[i]={
				score={},
				combo={},
				floor={},
				lastScore=0,
				lastCombo=0,
				lastFloor=0
		}
		for j=1,5 do			
			highscores[i].score[j]=bytesToInt(string.byte(prFile:read(1)),string.byte(prFile:read(1)),string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		end
		
		for j=1,5 do
			highscores[i].combo[j]=bytesToWord(string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		end
		
		for j=1,5 do
			highscores[i].floor[j]=bytesToWord(string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		end
		highscores[i].lastScore=bytesToInt(string.byte(prFile:read(1)),string.byte(prFile:read(1)),string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		highscores[i].lastCombo=bytesToWord(string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		highscores[i].lastFloor=bytesToWord(string.byte(prFile:read(1)),string.byte(prFile:read(1)))
		
	end
	
	profilesCount=pc
	
	prFile:close()
end

--profiles
--file format:
--[[
	byte profilesCount
	string profile list='p1;p2;p3;'


	(profilesCount*) profile_table={
		(5*) integer score
		(5*) word combo
		(5*) word floor
	}
]]

function updatePrFile()	
	--write new profiles.dat
	prFile=io.open("profiles.dat","w+")
	prFile:write(string.char(profilesCount))
	
	for i=1,profilesCount do
		prFile:write(profiles[i]..";")
	end
	
	for i=1,profilesCount do
		for j=1,5 do
			local b1,b2,b3,b4=intToBytes(highscores[i].score[j])
			prFile:write(string.char(b1),string.char(b2),string.char(b3),string.char(b4))
		end
		
		for j=1,5 do
			local b1,b2=wordToBytes(highscores[i].combo[j])
			prFile:write(string.char(b1),string.char(b2))
		end
		
		for j=1,5 do
			local b1,b2=wordToBytes(highscores[i].floor[j])
			prFile:write(string.char(b1),string.char(b2))
		end
		
		local ls=highscores[i].lastScore
		local lc=highscores[i].lastCombo
		local lf=highscores[i].lastFloor
		
		local b1,b2,b3,b4=intToBytes(ls)
		prFile:write(string.char(b1),string.char(b2),string.char(b3),string.char(b4))
		
		b1,b2=wordToBytes(lc)
		prFile:write(string.char(b1),string.char(b2))
		
		b1,b2=wordToBytes(lf)
		prFile:write(string.char(b1),string.char(b2))
	end
	
	prFile:close()
end

function desc(a,b)
	return a>b
end

function updateHighscores(s,c,f)
	local ns=highscores[profileChoice].lastScore
	local nc=highscores[profileChoice].lastCombo
	local nf=highscores[profileChoice].lastFloor
	
	if s>highscores[profileChoice].score[5] then
		ns=s
		highscores[profileChoice].score[5]=s
		table.sort(highscores[profileChoice].score,desc)
	end
	
	if c>highscores[profileChoice].combo[5] then
		nc=c
		highscores[profileChoice].combo[5]=c
		table.sort(highscores[profileChoice].combo,desc)
	end
	
	if f>highscores[profileChoice].floor[5] then
		nf=f
		highscores[profileChoice].floor[5]=f
		table.sort(highscores[profileChoice].floor,desc)
	end
			
	return ns,nc,nf
end

function gSort(a,b)
	return a.value>b.value
end

function makeGlobalHSTable()	
	for i=1,profilesCount do
		highscores.global.score[i]={}	
		highscores.global.score[i].profile=profiles[i]
		highscores.global.score[i].value=highscores[i].score[1]
		
		highscores.global.combo[i]={}
		highscores.global.combo[i].profile=profiles[i]
		highscores.global.combo[i].value=highscores[i].combo[1]
		
		highscores.global.floor[i]={}
		highscores.global.floor[i].profile=profiles[i]
		highscores.global.floor[i].value=highscores[i].floor[1]
	end
	
	table.sort(highscores.global.score,gSort)
	table.sort(highscores.global.combo,gSort)
	table.sort(highscores.global.floor,gSort)
end

function saveSettings()
	local chosenChars=""
	local chosenFloors=""
	for i=1,profilesCount do		
		chosenChars=chosenChars..settings.character[i]		
		chosenFloors=chosenFloors..settings.floor[i]
		if i<profilesCount then
			chosenChars=chosenChars..","
			chosenFloors=chosenFloors..","
		end
	end
	local lines={}
	lines[1]="settings={"
	lines[2]="	profile="..tostring(profileChoice)..","
	lines[3]="	character={"..chosenChars.."},"
	lines[4]="	floor={"..chosenFloors.."},"
	lines[5]="	mute="..tostring(menu.optionsMute)
	lines[6]="}"
	
	local set=io.open("settings.lua","w+")
		for i=1,table.getn(lines) do
			set:write(lines[i]..string.char(10))
		end
	set:close()
end

function clockRing()
	sounds.remains=sounds.global.ringing:time()
	if not menu.optionsMute and not gameOver then		
		if not is_zen then sounds.remains=2 end
		sounds.global.ringing:play()
	end
end

function loadCharSound(snd,name)
	sounds[snd]=wav.load("characters/"..chars[charChoice].."/"..name)
	if sounds[snd]==nil then
		sounds[snd]=wav.load("sounds/"..name)
	end
end

function playMenuSound(snd)
	if not menu.optionsMute then
		sounds.global[snd]:play()
	end
end

--//////////////////////////////////////////////////////////////////////////
--//////////////////////////////////////////////////////////////////////////
--//////////////////////////////////////////////////////////////////////////

collectgarbage()

require "settings"
require "jsnow"
require "characters"

screen.orientation(0)

scrWidth=screen.width()
scrHeight=screen.height()

loadingScr=image.load("images/loading.png")
loadingDot=image.load("images/loadingDot.png")
--loadingNoDots=image.load("images/loadingNoDots.png")

black50=color.new(0,0,0,128)
screen.fillrect(0,0,scrWidth,scrWidth,black50)
loadingScr:safeDraw(0,0)
screen.update()

loading=coroutine.create(loadingF)
coroutine.resume(loading,true)

profiles={}

highscores={
	{
		score={},
		combo={},
		floor={},
		lastScore,
		lastCombo,
		lastFloor
	},
	global={
		score={},
		combo={},
		floor={}
	}
}



--[[
b1,b2,b3,b4=intToBytes(262144)
print(b1.." "..b2.." "..b3.." "..b4)
print(bytesToInt(b1,b2,b3,b4))
]]

menu={
	welcomeScreen=false,
	mainMenu=true,
	instructMenu=false,
	creditsMenu=false,
	controlsMenu=false,
	charMenu=false,
	profileMenu=false,
	newProfileMenu=false,
	newProfileName="",
	profileSelected=profileChoice,
	profileListShift=0,
	highscoreMenu=false,
	hsGlobal=true,
	hsOwn=false,
	mainBG=image.load("images/menu1.jpg"),
	instructBG,
	profileBG,
	optBG,
	optionsMute=settings.mute,
	highscoreBG,
	highscoreTop={},
	hsTableShift=0,
	highscoreReset
	--arrowL=image.load("images/arrowL.png"),
	--arrowR=image.load("images/arrowR.png")
}
coroutine.resume(loading,true)

--load profiles
profilesCount=0
prFile=io.open("profiles.dat","r")
c=prFile:read(1)
prFile:close()
if c==nil then
	--createFirstProfile()
	menu.mainMenu=false
	menu.welcomeScreen=true
	--menu.newProfileMenu=true
else
	loadProfiles()
end

--choose profile
profileChoice=settings.profile

--choose character

charChoice=settings.character[profileChoice]
if charChoice>table.getn(chars) then
	charChoice=table.getn(chars)
end
possibleCharChoice=1
possibleFloorChoice=0

--load graphics, define player

pauseScr=image.load("images/pause.png")
coroutine.resume(loading,true)

world={
	g=9.81/2500,
	m=30,
	bEdge=220,
	lEdge=59,
	rEdge=389,
	width=400,
	floor=0,
	lastFloor=0,
	dropped=0,
	unlocked={},
	startFloor=settings.floor[profileChoice],
	fHeight=20,
	widthBetween={
		{min=4,max=7},
		{min=4,max=6},
		{min=3,max=5},
		{min=3,max=4},
		{min=3,max=4},
		{min=3,max=4},
		{min=3,max=4},
		{min=3,max=3},
		{min=3,max=3},
		{min=3,max=3},
		{min=2,max=3}
	},
		
	floors={
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0},
		{pos=0,width=0,style=0}
	},
	
	floorImages={},
	floorEdge=5,
	floor3DSurface=5,
	sideBar,
	sidebarShift=0,
	roll=false,
	shift=0,
	shiftCounter=0,
	shiftCounterBG=0,
	shiftCounterS=0,
	speed={0.5, 1, 1.5, 2, 2.5, 3},
	clock={	
		img,
		pointer={},
		pFrame=1,
		time=0,
		cycle=1,
		crazy=false
	},
	hurry=false
}

--load floor images

for i=1,11 do
	world.floorImages[i]={}
	world.floorImages[i][1]=image.load("images/floors/left"..tostring(i-1)..".png")
	coroutine.resume(loading,true)
	world.floorImages[i][2]=image.load("images/floors/middle"..tostring(i-1)..".png")
	coroutine.resume(loading,true)
	world.floorImages[i][3]=image.load("images/floors/right"..tostring(i-1)..".png")
	coroutine.resume(loading,true)
	world.floorImages[i][4]=image.load("images/floors/table"..tostring(i-1)..".png")
end

--load sidebar image
world.sideBar={image.load("images/sidebarLeft.png"),image.load("images/sidebarRight.png")}
coroutine.resume(loading,true)

-- load clock image
world.clock.img=image.load("images/clock/clock_main.png")
coroutine.resume(loading,true)

--load pointer images
for i=1,8 do
	world.clock.pointer[i]=image.load("images/clock/pointers"..tostring(i)..".png")
	coroutine.resume(loading,true)
end

function world.clock.drawPointer(f,ox,oy)
	local i=(f-1)%30
	local p=(f-1-i)/30
	local x,y=i%5,(i-i%5)/5
	
	world.clock.pointer[p+1]:draw(-x*50+ox,-y*58+oy,0,0,50,58)
end


--combometer
world.combometer={
	--main=image.load("images/combometer/combometer.png"),
	point={},
	time=0,
	appearing=false
}
coroutine.resume(loading,true)

world.combometer.base=image.load("images/combometer/combometer_base.png")
coroutine.resume(loading,true)

world.combometer.floors=image.load("images/combometer/floors.png")
coroutine.resume(loading,true)

world.combometer.noFloors=image.load("images/combometer/nofloors.png")
coroutine.resume(loading,true)

world.combometer.point[1]=image.load("images/combometer/point_half.png")
coroutine.resume(loading,true)
world.combometer.point[2]=image.load("images/combometer/point_full.png")
coroutine.resume(loading,true)

splash={
	hurryY=scrHeight,
	gameoverY,
	gameoverV=1,
	rewards={},
	isReward=false,
	rewardType=0,
	rewardZoom=0
}

splash.hurry=image.load("images/splashes/splashes01.png")
coroutine.resume(loading,true)

--load combo rewards
for i=1,11 do
	splash.rewards[i]=image.load("images/splashes/splashes"..string.format("%02d",tostring(i+1))..".png")
	coroutine.resume(loading,true)
end

splash.gameover=image.load("images/gameOver.png")
coroutine.resume(loading,true)

--simplified sine zoom TEST
--[[for i=12,156,12 do
	local rNum=8
	local ratio=math.sin(i/100)
	local width,height=math.round(splash.rewards[rNum]:width()*ratio),math.round(splash.rewards[rNum]:height()*ratio)
	print("w: "..width..", h: "..height)
	screen.fillrect(0,0,400,240,color.new(0,0,0))
	splash.rewards[rNum]:draw(math.floor(200-width/2),math.floor(120-height/2),width,height)
	screen.update()
	os.wait(40)
end
os.wait(2000)]]

splash.gameoverY=-splash.gameover:height()

--animations frame order
idle={1,10,1,11}
walk={2,3,4,5,6,7,8,9}
jump={{12},{13,14,15,16,17,18},{19,20,21,22,23,24,25,26}}
edge={{27,28},{29,30}}
chock=31

startRunningLeft=-2
startRunningRight=2
shortRunLeft=-1
shortRunRight=1
stopRunning=0
stepUp=0.5
stepDown=0.8

character={
	velocity=0,
	maxVelocity=15,
	jump=false,
	jumpTimer=0,
	jumpVelocity0=nil,
	jumpVelocity=0,
	jumpType=0,
	inAir=false,
	falling=false,
	action,
	lastAction=0,
	position={
		x=(world.rEdge+world.lEdge)/2-15,
		y=world.bEdge-52+world.floor3DSurface
	},
	lastY=world.bEdge-52+world.floor3DSurface,
	images={},
	previews={},
	width,
	defWidth,
	height=52,
	animTimer=0,
	idleIn=0,
	score=0,
	combo=false,
	comboJumps=0,
	comboFloors=0,
	comboReward=0,
	bestCombo=0
}

--load character animations

character.images[1]=image.load("characters/"..chars[charChoice].."/idle1.png")
coroutine.resume(loading,true)

character.width=character.images[1]:width()
character.defWidth=character.width

for i=2,9 do
	character.images[i]=image.load("characters/"..chars[charChoice].."/walk"..tostring(i-1)..".png")
	coroutine.resume(loading,true)
end



character.images[10]=image.load("characters/"..chars[charChoice].."/idle2.png")
coroutine.resume(loading,true)
character.images[11]=image.load("characters/"..chars[charChoice].."/idle3.png")
coroutine.resume(loading,true)

character.images[12]=image.load("characters/"..chars[charChoice].."/jump.png")
coroutine.resume(loading,true)

for i=13,18 do
	character.images[i]=image.load("characters/"..chars[charChoice].."/jump"..tostring(i-12)..".png")
	coroutine.resume(loading,true)
end

for i=19,26 do
	character.images[i]=image.load("characters/"..chars[charChoice].."/rotate"..tostring((i-19)*45)..".png")
	coroutine.resume(loading,true)
end

for i=27,30 do
	character.images[i]=image.load("characters/"..chars[charChoice].."/edge"..tostring(i-26)..".png")
	coroutine.resume(loading,true)
end

character.images[31]=image.load("characters/"..chars[charChoice].."/chock.png")
coroutine.resume(loading,true)

--load previews of other characters
for i=1,table.getn(chars) do
	character.previews[i]=image.load("characters/"..chars[i].."/idle1.png")
	coroutine.resume(loading,true)
end

--menu

menu.instructBG=image.load("images/menu_instructions/contentPaper.jpg")
coroutine.resume(loading,true)

menu.instructBorder=image.load("images/menu_instructions/onlyBorder.png")
coroutine.resume(loading,true)

menu.instructPages={}
menu.instructCrossFadeLeft={}
menu.instructCrossFadeRight={}

menu.instructPage=1
menu.instructSlide=0
menu.instructSlideOffset=0

for i=1,4 do
	menu.instructPages[i]=image.load("images/menu_instructions/page"..tostring(i)..".png")
	coroutine.resume(loading,true)
	menu.instructCrossFadeLeft[i]=image.load("images/menu_instructions/page"..tostring(i).."_blurLeft.png")
	coroutine.resume(loading,true)
	menu.instructCrossFadeRight[i]=image.load("images/menu_instructions/page"..tostring(i).."_blurRight.png")
	coroutine.resume(loading,true)
end

menu.wsBG=image.load("images/welcomeScreen.png")
coroutine.resume(loading,true)

menu.optBG=image.load("images/menu_option.png")
coroutine.resume(loading,true)
menu.highscoreBG=image.load("images/menu_highscore/highscore_main.jpg")
coroutine.resume(loading,true)

menu.unmutedBTN=image.load("images/unmutedBTN.png")
coroutine.resume(loading,true)

menu.profileBG=image.load("images/menu_profile/profile_main.png")
coroutine.resume(loading,true)
menu.profileSel=image.load("images/menu_profile/profile_sel.png")
coroutine.resume(loading,true)
menu.profileSelBG=image.load("images/menu_profile/profile_selBG.jpg")
coroutine.resume(loading,true)
menu.profileDel=image.load("images/menu_profile/profile_del.png")
coroutine.resume(loading,true)
menu.newProfileBG=image.load("images/menu_profile/profile_new.png")
coroutine.resume(loading,true)
menu.newProfileTF=image.load("images/menu_profile/textField.jpg")
coroutine.resume(loading,true)

menu.profileDeactivated=image.load("images/menu_profile/profile_deactivated.png")

menu.highscoreTop[1]=image.load("images/menu_highscore/highscore_main_top1.png")
coroutine.resume(loading,true)
menu.highscoreTop[2]=image.load("images/menu_highscore/highscore_main_top2.png")
coroutine.resume(loading,true)

menu.arrowUp=image.load("images/menu_highscore/arrowUp.png")
coroutine.resume(loading,true)
menu.arrowDown=image.load("images/menu_highscore/arrowDown.png")
coroutine.resume(loading,true)

--menu.highscoreReset=image.load("images/menu_highscore/highscore_reset.png")
--coroutine.resume(loading,true)

menu.highscoreHeading=image.load("images/menu_highscore/highscore_heading.png")
coroutine.resume(loading,true)

menu.creditsBG=image.load("images/menu_credits.jpg")
coroutine.resume(loading,true)

menu.quitImg=image.load("images/menu_exit.png")
coroutine.resume(loading,true)

keyboard={
	{"1","2","3","4","5","6","7","8","9","0"},
	{"q","w","e","r","t","y","u","i","o","p"},
	{"a","s","d","f","g","h","j","k","l","-"},
	{"z","x","c","v","b","n","m"},
	shift=false,
	caps=false
}

--createNewProfile("Nohajc")

for i=1,profilesCount do
	world.unlocked[i]=math.floor(highscores[i].floor[1]/100)
end

interval=10
acc=0
accSpeedError=0.01
accControl=true
enableAccIn=0
touchControl=false
idleDelay=30
lastLPF_x_dir=0
vMulti=5
factor = 0.6;
Timer = 0;

gameOver=false

bg={
	img=image.load("images/background.jpg"),
	shift=0
}
coroutine.resume(loading,true)

--ctrl=image.load("images/controls.png")
--coroutine.resume(loading,true)

--load font
font={
	number={}
}

for i=1,10 do
	font.number[i]=image.load("images/font/"..tostring(i%10)..".png")
	coroutine.resume(loading,true)
end

--load sounds
sounds={hello,pause,edge,gameover,jumpLo,jumpMid,jumpHi,global={ringing,confirm,select},rewards={}}

rewFiles={"good.wav","sweet.wav","great.wav","super.wav","wow.wav","amazing.wav","extreme.wav","fantastic.wav","splendid.wav","noWay.wav"}

loadCharSound("hello","hello.wav")
coroutine.resume(loading,true)
loadCharSound("pause","pause.wav")
coroutine.resume(loading,true)
loadCharSound("edge","edge.wav")
coroutine.resume(loading,true)
loadCharSound("gameover","falling.wav")
coroutine.resume(loading,true)
sounds.global.ringing=wav.load("sounds/ringing.wav")
coroutine.resume(loading,true)
loadCharSound("jumpLo","jump_lo.wav")
coroutine.resume(loading,true)
loadCharSound("jumpMid","jump_mid.wav")
coroutine.resume(loading,true)
loadCharSound("jumpHi","jump_hi.wav")
coroutine.resume(loading,true)

sounds.global.confirm=wav.load("sounds/confirm.wav")
coroutine.resume(loading,true)

sounds.global.select=wav.load("sounds/select.wav")
coroutine.resume(loading,true)

for i=1,10 do
	sounds.rewards[i]=wav.load("sounds/rewards/"..rewFiles[i])
	coroutine.resume(loading,true)
end

sounds.remains=0

sounds.maxVol=25

sounds.lastVol=nil

if audio.channel()==0 and not menu.optionsMute then
	sounds.maxVol=14
	if audio.volume()>sounds.maxVol then
		sounds.lastVol=audio.volume()
		audio.volume(sounds.maxVol)
	end
end

coroutine.resume(loading,false)

snow=coroutine.create(snowF)

--coroutine.resume(snow,true)

drawMenu()
loadingScr:close()
loadingDot:close()
--loadingNoDots:close()

white=color.new(255,255,255)
text.color(white)
text.size(14)

pause=false
playing=false

--replay

record=false
replay=false

is_zen=isZen()

if is_zen then
	while (accelerometer.open() ~= 0) do
		os.sleep(5)
	end
else
	accControl=false
	touchControl=true
	--record=false
	--replay=true
	interval=20
	world.g=9.81/5000
end

accelerometer.set_datatype("xyz")
accelerometer.set_samplerate(100)



--combo counter value
cc=0

--touch scroll coordinate
tsY=0

--GAME LOOP

oldtime=os.ostime()

exit=0
charSlide=0
floorSlide=0

function gameLoop()
	while true do
		if control.read()==1 and gameOver==false then	

			if playing==false then			
				if control.isTouch()==1 then
					if touch.move()==1 then
						if menu.charMenu then
							if touch.charArea() then
								local curPos,y=touch.pos()
								if curPos<tsX then
									charSlide=1
								elseif curPos>tsX then
									charSlide=-1
								end
							elseif touch.floorArea() then
								local curPos,y=touch.pos()
								if curPos<tsX then
									floorSlide=1
								elseif curPos>tsX then
									floorSlide=-1
								end
							end
						elseif menu.highscoreMenu then
							local x,curPos=touch.pos()
							local shift=menu.hsTableShift+(curPos-tsY)*2
							tsY=curPos
							if shift>=-320 and shift<=0 then
								menu.hsTableShift=shift
							elseif shift<-320 then
								menu.hsTableShift=-320
							else
								menu.hsTableShift=0
							end							
							drawMenu()
						elseif menu.profileMenu and touch.profileList() then
							if profilesCount*46>210 then
								local x,curPos=touch.pos()
								local shift=menu.profileListShift+(curPos-tsY)*2
								tsY=curPos							
								if shift>=-profilesCount*46+210 and shift<=0 then
									menu.profileListShift=shift
								elseif shift<-profilesCount*46+210 then
									menu.profileListShift=-profilesCount*46+210
								else
									menu.profileListShift=0
								end
								drawMenu()
							end
						elseif menu.instructMenu then
							local curPos,y=touch.pos()
							if curPos<tsX then
								menu.instructSlide=1								
							elseif curPos>tsX then
								menu.instructSlide=-1
							end
						end	
						
						for i=1,100 do control.read() end
					elseif touch.click()==1 then
						if menu.mainMenu then
							if touch.play() then
								playing=true								
								initGame()
								redraw()
							elseif touch.instructions() then
								playMenuSound("select")
								menu.mainMenu=false
								menu.instructMenu=true
								drawMenu()								
							elseif touch.profile() then
								playMenuSound("select")
								menu.mainMenu=false
								menu.profileMenu=true
								menu.profileSelected=profileChoice
								drawMenu()												
							elseif touch.highscores() then
								playMenuSound("select")
								menu.hsTableShift=0
								makeGlobalHSTable()
								menu.mainMenu=false
								menu.highscoreMenu=true
								drawMenu()
							elseif touch.options() then
								playMenuSound("select")
								menu.mainMenu=false
								menu.charMenu=true
								possibleCharChoice=charChoice
								possibleFloorChoice=world.startFloor
								--menu.controlsMenu=true
								drawMenu()
							elseif touch.credits() then
								menu.mainMenu=false
								menu.creditsMenu=true
								drawMenu()
							elseif touch.exit() then
								playMenuSound("confirm")
								if exit==0 then
									break
								end
							end
						elseif menu.profileMenu then
							if touch.profileExit() then								
								menu.profileMenu=false
								menu.mainMenu=true
								drawMenu()
							elseif touch.profileList() then
								local x,y=touch.pos()
								local no=math.floor((y-17-menu.profileListShift)/47)+1								
								if no<=profilesCount then
									menu.profileSelected=no
									drawMenu()
								end
							elseif touch.profileListUp() then
								menu.profileListShift=0
								drawMenu()
							elseif touch.profileListDown() then
								if profilesCount*46>210 then
									menu.profileListShift=-profilesCount*46+210
									drawMenu()
								end
							elseif touch.profileLoad() then
								playMenuSound("select")
								
								settings.character[profileChoice]=charChoice
								
								profileChoice=menu.profileSelected
								charChoice=settings.character[profileChoice]
								world.startFloor=settings.floor[profileChoice]
								updateChar()
								drawMenu()
								
							elseif touch.profileNew() then
								playMenuSound("select")
								menu.profileMenu=false
								menu.newProfileMenu=true
								drawMenu()
							elseif touch.profileDel() then
								if profilesCount>1 then
									playMenuSound("select")
									delProfileQuery()
								end
							end
						elseif menu.newProfileMenu then
							local isKeyb,key=touch.keyboard()
							if isKeyb then
								playMenuSound("select")
								if key=="shift" then
									keyboard.shift=not keyboard.shift
									drawMenu()
								elseif key=="caps" then
									keyboard.caps=not keyboard.caps
									drawMenu()
								elseif key=="backspace" then
									if menu.newProfileName:len()>0 then
										menu.newProfileName=menu.newProfileName:sub(1,-2)
									end
									drawMenu()
								elseif menu.newProfileName:len()<8 then
									if (keyboard.shift and not keyboard.caps) or (not keyboard.shift and keyboard.caps) then
										key=string.upper(key)
									end
									if keyboard.shift then keyboard.shift=false end
									
									menu.newProfileName=menu.newProfileName..key
									
									drawMenu()
								end
							elseif touch.profileOK() and menu.newProfileName~="" then
								playMenuSound("confirm")
								createNewProfile(menu.newProfileName)
								menu.profileSelected=profilesCount
								profileChoice=profilesCount								
								menu.newProfileName=""
								menu.newProfileMenu=false
								menu.profileMenu=true
								drawMenu()
								
							elseif touch.profileBack() then
								if profilesCount==0 then
									break
								end
								menu.newProfileName=""
								menu.newProfileMenu=false
								menu.profileMenu=true
								drawMenu()
							end
							
						elseif menu.highscoreMenu then
							if touch.arrowU() then
								menu.hsTableShift=0
								drawMenu()
							elseif touch.arrowD() then
								menu.hsTableShift=-320
								drawMenu()
							elseif menu.hsGlobal then
								if touch.hsOwn() then
									menu.hsGlobal=false
									menu.hsOwn=true
									drawMenu()
								end
							elseif menu.hsOwn then
								if touch.hsGlobal() then
									menu.hsOwn=false
									menu.hsGlobal=true									
									drawMenu()
								end
							end				
						elseif menu.controlsMenu then
					
							if touch.enableAcc() then
								accControl=true
								touchControl=false
								
							elseif touch.enableTouch() then
								accControl=false
								touchControl=true
							end
						elseif menu.charMenu then
							if touch.optionsOK() then
								playMenuSound("confirm")
								menu.charMenu=false
								menu.mainMenu=true
								charChoice=possibleCharChoice
								settings.character[profileChoice]=charChoice
								world.startFloor=possibleFloorChoice
								settings.floor[profileChoice]=world.startFloor
								updateChar()
								drawMenu()
							elseif touch.optionsVolMute() then
								menu.optionsMute=not menu.optionsMute
								if menu.optionsMute then
									sounds.maxVol=25
								end
								drawMenu()
							elseif touch.optionsVolUp() then								
								local vol=audio.volume()+1
								if audio.channel()==1 then
									sounds.maxVol=25
								end
								if vol<=sounds.maxVol then
									audio.volume(vol)									
								end
								playMenuSound("select")
								drawMenu()
							elseif touch.optionsVolDown() then								
								local vol=audio.volume()-1
								if vol>=0 then
									audio.volume(vol)
								end
								playMenuSound("select")
								drawMenu()
							end
						elseif menu.welcomeScreen then
							if touch.wsNext() then
								menu.welcomeScreen=false
								menu.newProfileMenu=true
								drawMenu()
							end
						end
					
					elseif touch.down()==1 then
						if menu.instructMenu or menu.highscoreMenu or menu.profileMenu or (menu.charMenu and (touch.charArea() or touch.floorArea())) then
							--local x
							tsX,tsY=touch.pos()
						end					
					elseif touch.up()==1 then
						if menu.charMenu then
							if charSlide~=0 then								
								if charSlide==-1 then
									if possibleCharChoice>1 then
										possibleCharChoice=possibleCharChoice-1
									else
										possibleCharChoice=table.getn(chars)
									end
									drawMenu()
								elseif charSlide==1 then
									if possibleCharChoice<table.getn(chars) then
										possibleCharChoice=possibleCharChoice+1
									else
										possibleCharChoice=1
									end
									drawMenu()
								end							
								charSlide=0
							end
							if floorSlide~=0 then
								if floorSlide==-1 then
									if possibleFloorChoice>0 then
										possibleFloorChoice=possibleFloorChoice-1
									end
									drawMenu()
								elseif floorSlide==1 then
									if possibleFloorChoice<world.unlocked[profileChoice] and possibleFloorChoice<table.getn(world.floorImages)-1 then
										possibleFloorChoice=possibleFloorChoice+1
									end
									drawMenu()
								end
								floorSlide=0
							end
						elseif menu.instructMenu then
							if menu.instructSlide==-1 and menu.instructPage>1 then
								drawMenu()
							elseif menu.instructSlide==1 and menu.instructPage<table.getn(menu.instructPages) then
								drawMenu()
							else
								menu.instructSlide=0
							end
						end
					end
				elseif control.isButton()==1 and button.click()==1  then
					if menu.instructMenu then
						menu.instructMenu=false
						menu.mainMenu=true
						
						menu.instructPage=1
						
						drawMenu()
					elseif menu.creditsMenu then
						menu.creditsMenu=false
						menu.mainMenu=true
						drawMenu()
					elseif menu.charMenu then
						menu.charMenu=false
						menu.mainMenu=true						
						drawMenu()
					elseif menu.profileMenu then
						menu.profileMenu=false
						menu.mainMenu=true
						drawMenu()
					elseif menu.newProfileMenu then
						if profilesCount==0 then							
							break
						end
						menu.newProfileName=""
						menu.newProfileMenu=false
						menu.profileMenu=true
						drawMenu()
					elseif menu.highscoreMenu then
						menu.highscoreMenu=false
						menu.mainMenu=true
						drawMenu()
					elseif menu.controlsMenu then
						menu.controlsMenu=false
						menu.mainMenu=true
						drawMenu()
					elseif menu.mainMenu or menu.welcomeScreen then
						if exit==0 then
							break
						end
					end
				end
			else	
				if pause then
					if (control.isTouch()==1) and (touch.click()==1) then
						pause=false
						drawSidebar()			
					elseif control.isButton()==1 then
						if button.click()==1 then
							exitQuery()
						end
					end			
				else				
					if control.isTouch()==1 then
						if touch.down()==1 then
							if touch.left() and touchControl then
								character.velocity=0
								character.action=startRunningLeft
							elseif touch.right() and touchControl then
								character.velocity=0
								character.action=startRunningRight
							end
						elseif touch.click()==1 then
							if touch.left() and touchControl then
								character.action=shortRunLeft
							elseif touch.right() and touchControl then
								character.action=shortRunRight
							else
								pause=true
								if not menu.optionsMute then
									sounds.pause:play()
								end
								redraw()
							end
						elseif touch.hold()==1 then
			
						elseif touch.move()==1 then
							if touch.left() and touchControl then
								character.action=startRunningLeft
								if character.lastAction~=-1 then character.velocity=0 end					
							elseif touch.right() and touchControl then
								character.action=startRunningRight
								if character.lastAction~=1 then character.velocity=0 end
							end					
						elseif touch.up()==1 and touchControl then
							character.action=stopRunning
						end
					elseif control.isButton()==1 then
						if (button.home()==1) and (button.event()==4) then
							character.jump=true
						elseif (character.jump==true) and ((button.home()==1) and ((button.event()==1) or (button.event()==8))) then
							character.jump=false
						end										
					elseif (control.isSensor()==1) and (accControl) then
						acc=accelerometer.getdata("x")
						lastLPF_x_dir = (acc * factor) + (lastLPF_x_dir * (1.0 - factor));		
					end
				end
			end
		elseif not playing and menu.mainMenu then
			drawMenu()
		end	
				
		if (pause==false) and playing then
			--updatePlayerPos(lastLPF_x_dir)
			chy=nil
			if replay then
				local s=repFile:read(1)
				if s~=nil then				
					local byte=string.byte(s)
						
					if byte>=128 then
						character.jump=true
						byte=byte-128
					else
						character.jump=false
					end
					
					if byte>16 then byte=byte-32 end
					v=byte
			
					byte=string.byte(repFile:read(1))
					v=v+byte/100
						
					--[[chy=string.byte(repFile:read(1))
					if chy>=128 then chy=chy-256 end]]
				
					--r=string.byte(repFile:read(1))
				
				else
					v=character.velocity
					r=nil
				end
				--print(v)
			elseif accControl then
				v=lastLPF_x_dir
			else v=character.action end
		
			updatePlayerPos(v,chy)
			redraw()
				
			if character.position.y+character.height+world.shift>scrHeight and gameOver==false then
				character.inAir=true
				character.falling=true
				gameOverF()
				--resetGame()
			end
		
			--combo counter
		
			if character.combo and world.combometer.time>0 then			
				cc=(cc+1)%5
				if cc==0 then
					world.combometer.time=world.combometer.time-1
					drawCombometer()
				end
			
				if world.combometer.time==0 then				
					comboEnd(true)
					cc=0
				end	
			end
		
			if gameOver==false or character.position.y+world.shift<=scrHeight then
				if world.floor>=5 then world.roll=true end
		
				if world.roll then
					if world.clock.crazy then
						world.clock.time=world.clock.time-1
						if world.clock.time==0 then world.clock.time=60 end
				
						drawClock(world.clock.time*4)				
					else			
						world.clock.time=world.clock.time+1			
		
						if world.clock.time==720 then 
							world.clock.time=0
							world.clock.cycle=world.clock.cycle+1
							if world.clock.cycle<6 then						
								world.hurry=true
								clockRing()
								world.shiftCounter=world.speed[world.clock.cycle]
								world.shiftCounterBG=world.speed[world.clock.cycle]/2
							elseif world.clock.cycle==6 then
								world.hurry=true
								clockRing()
								world.clock.crazy=true
								world.clock.time=60
							end
						end
			
						
						if world.clock.time%3==0 then
							drawClock(world.clock.time/3+1)
							--world.clock.pFrame=world.clock.pFrame+1
							--if world.clock.pFrame==241 then world.clock.pFrame=1 end
						elseif world.hurry then
							drawClock(math.floor(world.clock.time/3)+1)
						end
						
						
					end
			
					autoRoll()
				
				end
			else
				--game over
				if math.abs(splash.gameoverV)>0 then
					splash.gameoverV=splash.gameoverV+world.g*world.m*40
					splash.gameoverY=math.floor(splash.gameoverY+splash.gameoverV)
					--print(splash.gameoverY)
					if splash.gameoverY>0 then
						splash.gameoverY=0
						splash.gameoverV=math.fix(-3*splash.gameoverV/7,1)
					end
				else
					goCheckButtons()
				end
			end			
		end
	
		os.wait(interval)
		local newtime=os.ostime()
			if sounds.remains>0 then
				sounds.remains=sounds.remains-(newtime-oldtime)
				--print(sounds.remains)
			elseif sounds.remains<0 then
				sounds.remains=0
			end
		oldtime=newtime
		
		if exit>0 then exit=exit-1 end
		--timer=timer+interval
	end
end

--log=io.open("log.txt","a+")

--s,e=pcall(gameLoop)
gameLoop()

--if e~=nil then
--	log:write(tostring(e))
--end

--log:close()

saveSettings()

--cleaning
accelerometer.close()

for i,v in ipairs(character.images) do 
	v:close()
end

splash.hurry:close()
splash.gameover:close()

for i,v in ipairs(splash.rewards) do
	v:close()
end

world.combometer.base:close()
world.combometer.noFloors:close()
world.combometer.floors:close()


world.combometer.point[1]:close()
world.combometer.point[2]:close()

for i,v in ipairs(font.number) do
	v:close()
end

pauseScr:close()
--ctrl:close()
world.clock.img:close()
for i,v in ipairs(world.clock.pointer) do
	v:close()
end
world.sideBar[1]:close()
world.sideBar[2]:close()
bg.img:close()

for i=1,table.getn(world.floorImages) do
	for j,v in ipairs(world.floorImages[i]) do
		v:close()
	end
end

for i=1,table.getn(chars) do
	character.previews[i]:close()
end

for i,v in ipairs(menu.highscoreTop) do
	v:close()
end

for k,v in pairs(sounds) do
	if string.find(tostring(sounds[k]),"wave")~=nil then
		sounds[k]:close()
	end
end

for k,v in pairs(sounds.global) do
	if string.find(tostring(sounds.global[k]),"wave")~=nil then
		sounds.global[k]:close()
	end
end

for i,v in ipairs(sounds.rewards) do
	v:close()
end

menu.instructBG:close()
menu.instructBorder:close()

for i,v in ipairs(menu.instructPages) do
	v:close()
end

for i,v in ipairs(menu.instructCrossFadeLeft) do
	v:close()
end

for i,v in ipairs(menu.instructCrossFadeRight) do
	v:close()
end

menu.creditsBG:close()
menu.quitImg:close()
menu.wsBG:close()
menu.profileDeactivated:close()
menu.newProfileTF:close()
menu.newProfileBG:close()
menu.profileSel:close()
menu.profileSelBG:close()
menu.profileDel:close()
menu.profileBG:close()
menu.arrowUp:close()
menu.arrowDown:close()
menu.highscoreHeading:close()
menu.highscoreBG:close()
--menu.highscoreReset:close()
menu.unmutedBTN:close()
menu.optBG:close()
menu.mainBG:close()

if sounds.lastVol~=nil then
	audio.volume(sounds.lastVol)
end

screen.clear()
collectgarbage()
